########################################################################################################################
#
# Projet : Robot Rover
# Module principal : inteface graphique
#
# fonctions :
# trait_Dj(): lance l'algorithme de Dijkstra
#
# trait_robot(): exécute le parcours par le robot et initialise le port série
#
#
########################################################################################################################

# !/usr/bin/python3

from data_graphe import coord_point, graphe
from calcul_Dijkstra import calc_Dijkstra, exec_Dijk
from tkinter import *
import portcom



def trait_Dj():
    """Cette fonction lance l'éxécution de l'algorithme du Dijkstra"""

    # affectation de la source
    source = s0.get()
    # affectation de la destinacion
    destination = s1.get()

    # affiche les messages de retour du calcul de Dj
    message1, message2 = calc_Dijkstra(source, destination)
    label3 = Label(fenetre1, text=message1 + '        ',font='Helvetica 10 bold')
    label3.place(x=0, y=150)
    label4 = Label(fenetre1, text=message2 + '                                                            ',font='Helvetica 10 bold')
    label4.place(x=0, y=180)

    # si parcours calculé non vide
    if not ((message2[-2:] == ': ')):
        bouton2.config(state="normal")  # autorise l'éxécution du robot
    else :
        bouton2.config(state = "disabled")

def trait_robot():
    """Cette fonction fait exécuter le parcours par le robot qui communique via le port série en Bluetooth"""

    portcom.com_name = s2.get()
    print('Port Com choisi :', portcom.com_name)
    exec_Dijk()

# initialisation des listes défilantes des spinbox :

com_list = []
com_list = portcom.Affich_PortCom() ## recherche des ports COMX disponibles pour le Bluetooth :

# liste des noms des points de la carte ('A','B' ...)
point_list = [x for x in graphe.keys()]

# Création d'une fenêtre :
fenetre1 = Tk()
fenetre1.geometry("480x500")  # taille
fenetre1.title("ROVER")  # titre
fenetre1.resizable(height=False, width=False)

canvas1 = Canvas()
# Les champs de la fenêtre :

#########################################################

# Point de départ :
label0 = Label(fenetre1, text="Point de départ :",font='Helvetica 10 bold')
# label0.pack(expand= True)
label0.place(x=0, y=65)
s0 = Spinbox(fenetre1, values=point_list, width=5, wrap=True)
s0.place(x=130, y=65)
#########################################################

# Point d'arrivée :
label1 = Label(fenetre1, text="Point d'arrivée :  ",font='Helvetica 10 bold')
# label1.pack()
label1.place(x=0, y=100)
s1 = Spinbox(fenetre1, values=point_list, width=5, wrap=True)
s1.place(x=130, y=100)
#########################################################

# Port Com :
label2 = Label(fenetre1, text="Port Com série :  ")

label2.place(x=0, y=10)
s2 = Spinbox(fenetre1, values=com_list, width=15, wrap=True)
s2.place(x=100, y=10)
#########################################################

# Information d'orientation du robot :
label3 = Label(fenetre1, text=" Au point de départ : Rover est orienté  // la longueur du tableau en direction de E",font='Helvetica 9 bold')
label3.place(x=0, y=250)
#########################################################

# Bouton1 calculer le Dijkstra :
bouton1 = Button(fenetre1, text="Calculer le Dijkstra",bg='#ffffff', activebackground='green', command= trait_Dj)
bouton1.place(x=220, y=80)
#########################################################

# Bouton2 Exécuter le parcours :
bouton2 = Button(fenetre1, text=" Exécuter le parcours du robot ",bg='#ffffff', activebackground='red', command=trait_robot)
bouton2.place(x=130, y=300)
bouton2.config(state="disabled")  # désactive l'éxécution du robot tant que le Djkstra n'est pas calculé
#########################################################

# Bouton3 de fermeture du programme :
bouton3 = Button(fenetre1, text="Close",bg='pink',command=fenetre1.destroy)
bouton3.place(x=350, y=400)
########################################################

# Ligne de séparation
canvas1.create_line(0, 230, 400, 230, width=5, fill='blue')
canvas1.pack()


fenetre1.mainloop()
